unit dpm;

interface

uses ffurie;


type
  tPowerArray = Array [0..N div 2] of byte;

function DPVoice(var V1,V2 : SegVoice) : Word;
function PowerSeg(It : SegVoice) : LongInt;
function PowerSpectr(It : Spectr) : LongInt;
procedure DelFreq0(var It : SegVoice);

implementation

uses Draw,Graph;

const
  Nd2 = N div 2;

type
  pLongArray = ^tLongArray;
  tLongArray = Array[0..Nd2-1] of LongInt;

function PowerSpectr(It : Spectr) : LongInt;
var
  P : Real;
  rn : Integer;
begin
  P := 0;
  for rn := 0 to Nd2 - 1 do
  P := P + sqr(LongInt(It[rn].Re)) + sqr(LongInt(It[rn].Jm));
  P := P/N*2;
  PowerSpectr := Round(P);
end;

function Spectr2Power(S : Spectr;var D : tLongArray) : LongInt;
var
  rn : Integer;
  Max : LongInt;
begin
  Max := 0;
  for rn := 0 to Nd2 - 1 do
  begin
    D[rn] := sqr(LongInt(S[rn].Re)) div 4 + sqr(LongInt(S[rn].Jm)) div 4;
    if Max < D[rn] then Max := D[rn];
  end;
  Spectr2Power := Max;
end;

function PowerSeg(It : SegVoice) : LongInt; assembler;
asm
  push ds
  lds si,It
  mov cx,N
  xor bx,bx
  xor dx,dx
  cld
@1:
  lodsb
  imul al
  add bx,ax
  adc dx,0
  loop @1
  pop ds
  mov ax,bx
end;

function Max(a1, a2, a3 : Word) : Word;
var
  M : Word;
begin
  if a1 > a2 then M := a1 else M := a2;
  if M < a3 then M := a3;
  Max := M;
end;

{ !!!!!!!!!!!!  祭  㭪 !!!!!!!!!!!! }
function DP(var p1,p2 : tPowerArray) : Word;
var
  F1j,Fi1,F11,i,j : Word;
  Fi : Array[0..N div 2 - 1] of Word;

function LP : byte;
begin
  if (P1[i] < P1[i+1]) xor (P2[j] < P2[j+1]) then LP := 0
  else LP := $FF - abs(P1[i] - P2[j]);
end;

begin
  FillChar(Fi,SizeOf(Fi),#0);
  for i := 0 to Nd2-1 do
  begin
    F1j := 0; Fi1 := 0;
    for j := 0 to Nd2-1 do
    begin
      F11 := F1j;
      F1j := Fi[j];
      Fi1 := Max(F11+LP, F1j, Fi1);
      Fi[j] := Fi1;
    end;
  end;
  DP := Fi1;
end;

function DPVoice(var V1,V2 : SegVoice) : Word;
var
  P1LowMin : Boolean;
  S1,S2 : pSpectr;
  L1,L2 : pLongArray;
  divP,rp1,rp2 : Real;
  P1 : LongInt Absolute rP1;
  P2 : LongInt Absolute rP2;
  M1,M2 : Real;
  k1,k2 : Real;
  rn : Word;
  A1 : tPowerArray;
  A2 : tPowerArray;
const
  MinPower = 40;
begin
  P1 := PowerSeg(V1); P2 := PowerSeg(V2);
  P1LowMin := P1 < MinPower;
  if P1LowMin xor (P2 < MinPower) then
  begin
    DPVoice := 0; Exit;
  end;
  if P1LowMin then
  begin
    DPVoice := 32000; Exit;
  end;
  New(S1); New(S2); New(L1); New(L2);
  ToSpectr(V1,S1^);            ToSpectr(V2,S2^);
  M1 := Spectr2Power(S1^,L1^); M2 := Spectr2Power(S2^,L2^);
  rp1 := PowerSpectr(S1^);
  rp2 := PowerSpectr(S2^);
  divP := rP2/rP1;
  M1 := M1 * divP;
  if M1 > M2 then k2 := M1 / 250
  else k2 := M2 / 250;
  k1 := k2/divP;
  M1 := 0; M2 := 0; rP1 := 0; rP2 := 0;
  for rn := 0 to Nd2-1 do
  begin
    rP1 := rp1 + L1^[rn] / k1;
    rP2 := rp2 + L2^[rn] / k2;
    A1[rn] := Round(L1^[rn] / k1);
    A2[rn] := Round(L2^[rn] / k2);
    if L1^[rn] > M1 then M1 := L1^[rn];
    if L2^[rn] > M2 then M2 := L2^[rn];
  end;
  for rn := 2 to Nd2 - 3 do
  begin
    A1[rn] :=
    (3*A1[rn] + 2*(A1[rn-1] + A1[rn+1]) + A1[rn-2] + A1[rn+2])
    div 9;
    A2[rn] :=
    (3*A2[rn] + 2*(A2[rn-1] + A2[rn+1]) + A2[rn-2] + A2[rn+2])
    div 9;
  end;
  DPVoice := DP(A1,A2);
  ClearDevice;
  DrawVoice(V1);
  DrawVoice(V2);
  DrawPower(A1);
  DrawPower(A2);
  Dispose(S1);
  Dispose(S2);
  Dispose(L1);
  Dispose(L2);
end;

procedure DelFreq0(var It : SegVoice); assembler; { N   256 }
asm
  mov cx,N
  mov bx,cx
  push ds
  lds si,It
  xor dx,dx
  xor ah,ah
  cld
@1:
  lodsb
  cbw
  add dx,ax
  loop @1
  mov ax,N-1
  and ax,dx
  mov cl,Lg
  sar dx,cl
  mov cx,bx
  mov si,Word(It)
  mov bx,ax
@2:
  sub [si],dl
{----}
  dec bx
  jnz @3
  dec Byte Ptr [si]
  mov bx,ax
@3:
{----}
  inc si
  loop @2;
  pop ds
end;


end.