unit draw;

interface

uses graph,ffurie,dpm;

procedure DrawAmpl(X,Y : Integer;var It : Spectr);
procedure DrawPower(It : tPowerArray);
procedure DrawFase(X,Y : Integer;var It : Spectr);
procedure DrawSpectr(X,Y : Integer;var It : Spectr; W : Boolean);
procedure DrawNai(It : Spectr);
procedure DrawVoice(var It : SegVoice);

implementation


var
  DrawA : Array [0..N div 2 -1] of Integer;

procedure DrawAmpl(X,Y : Integer; var It : Spectr);
var
 rn : Integer;
 kX : Real;
begin
  for rn := 0 to N div 2 - 1 do
  begin
    DrawA[rn] := (sqr(LongInt(It[rn].Re)) + sqr(LongInt(It[rn].Jm)))
    div $1000;
  end;
  kX := GetMaxX*2./N;
  MoveTo(X,GetMaxY-Y);
  for rn := 0 to N div 2 - 1 do LineTo(X+Round(rn*kX),GetMaxY-DrawA[rn]-Y);
end;

procedure DrawPower(It : tPowerArray);
var
 rn : Integer;
 kX : Real;
begin
  kX := GetMaxX *2./N;
  for rn := 0 to N div 2 - 1 do LineTo(Round(rn*kX),GetMaxY-It[rn]);
end;

procedure DrawFase(X,Y : Integer; var It : Spectr);
var
 rn : Integer;
 kX : Real;
begin
  for rn := 0 to N div 2 - 1 do
  begin
    if It[rn].Re <> 0 then
    DrawA[rn] := Round(arctan(It[rn].Jm/It[rn].Re)*100)
    else DrawA[rn] := 0;
  end;
  kX := GetMaxX/N*2;
  MoveTo(X,GetMaxY-Y);
  for rn := 0 to N div 2 - 1 do LineTo(X+Round(rn*kX),GetMaxY-DrawA[rn]-Y);
end;

procedure DrawSpectr(X,Y : Integer; var It : Spectr; w : boolean);
var
 rn : Integer;
 kX : Real;
begin
  for rn := 0 to N div 2 - 1 do
  begin
    if W then DrawA[rn] := It[rn].Re
    else DrawA[rn] := It[rn].Jm;
    end;
  kX := GetMaxX/N*2;
  MoveTo(X,GetMaxY-Y);
  for rn := 0 to N div 2 - 1 do LineTo(X+Round(rn*kX),GetMaxY-DrawA[rn]-Y);
end;

procedure DrawNai(It : Spectr);
var
  rn : Word;
begin
  for rn := 0 to N div 2 - 1 do
  begin
    Inc(It[rn].Re,428);
    Inc(It[rn].Jm,128);
  end;
  DrawPoly(N div 2 ,It);
end;



procedure DrawVoice(var It : SegVoice);
var
 rn : Word;
 kX : Real;
 kY : Real;
begin
  kX := GetMaxX/N;
  MoveTo(0,0);
  for rn := 0 to N-1 do
  begin
    LineTo(Round(rn*kX), It[rn]+127);
  end;
end;

end.